local _G = getfenv(0)
local LibStub = _G.LibStub
local Heatsink = LibStub("AceAddon-3.0"):GetAddon("Heatsink", "AceEvent-3.0", "AceTimer-3.0")
local L = LibStub:GetLibrary("AceLocale-3.0"):GetLocale("Heatsink")

local GetSpellInfo = _G.GetSpellInfo
local pairs = _G.pairs

local FIRE = L["%s School"]:format(_G.STRING_SCHOOL_FIRE)
local SHADOW = L["%s School"]:format(_G.STRING_SCHOOL_SHADOW)
local FROST = L["%s School"]:format(_G.STRING_SCHOOL_FROST)
local HOLY = L["%s School"]:format(_G.STRING_SCHOOL_HOLY)
local NATURE = L["%s School"]:format(_G.STRING_SCHOOL_NATURE)
local ARCANE = L["%s School"]:format(_G.STRING_SCHOOL_ARCANE)
local PHYSICAL = L["%s School"]:format(_G.STRING_SCHOOL_PHYSICAL)

local slots = {	"Trinket0Slot", 
		"Trinket1Slot",
		"Finger0Slot",
		"Finger1Slot",
		"HeadSlot"
	}

local substitution = {
	[(GetSpellInfo(1499))] = L["Traps"], -- 1499 Freezing Trap
	[(GetSpellInfo(13795))] = L["Traps"], -- 13795 Immolation Trap
	[(GetSpellInfo(13809))] = L["Traps"], -- 13909 Immolation Trap
	[(GetSpellInfo(13813))] = L["Traps"], -- 13813 Explosive Trap
	[(GetSpellInfo(34600))] = L["Traps"], -- 34600 Snake Trap
	[(GetSpellInfo(8042))] = L["Shocks"], -- 8042 Earth Shock
	[(GetSpellInfo(8056))] = L["Shocks"], -- 8056 Frost Shock
	[(GetSpellInfo(8050))] = L["Shocks"], -- 8050 Flame Shock
	[(GetSpellInfo(53408))] = L["Judgement"], -- Judgement of Wisdom
	[(GetSpellInfo(20271))] = L["Judgement"], -- Judgement of Light
	[(GetSpellInfo(53407))] = L["Judgement"], -- Judgement of Justice
	[(GetSpellInfo(16979))] = (GetSpellInfo(49377)), -- 16979 Feral Charge - Bear, 49377 Feral Charge (Talent)
	[(GetSpellInfo(49376))] = (GetSpellInfo(49377)), -- 16979 Feral Charge - Cat,  49377 Feral Charge (Talent)
	-- items
	[L["Mana Jade"]] = L["Stones"],
	[L["Mana Ruby"]] = L["Stones"],
	[L["Mana Citrine"]] = L["Stones"],
	[L["Mana Agate"]] = L["Stones"],
	[L["Mana Emerald"]] = L["Stones"],
	[L["Healthstone$"]] = L["Stones"],
	[L["Potion"]] = L["Potions"],
	[L["Blue Ogre Brew Special"]]= L["Potions"],  --Ogri'la
	[L["Red Ogre Brew Special"]] = L["Potions"],  --Ogri'la
	[L["Blue Ogre Brew"]]= L["Potions"],  --Ogri'la
	[L["Red Ogre Brew"]] = L["Potions"],  --Ogri'la
	[L["Bottled Nethergon Energy"]] = L["Potions"],  --Tempest Keep
	[L["Bottled Nethergon Vapor"]] = L["Potions"],   --Tempest Keep
	[L["Cenarion Mana Salve"]] = L["Potions"],   --Cenarion Expedition
	[L["Cenarion Healing Salve"]] = L["Potions"],   --enarion Expedition
	[L["Major Healing Draught"]] = L["Potions"],   --PvP
	[L["Major Mana Draught"]] = L["Potions"],   --PvP
	[L["Superior Mana Draught"]] = L["Potions"],   --PvP
	[L["Superior Healing Draught"]] = L["Potions"],   --PvP
}

local schoolcd = {
	["WARLOCK"] = {
		[SHADOW] = 686, -- 686 Shadow Bolt 
		[FIRE]   = 5676, -- 5676 Searing Pain
	},
	["MAGE"] = {
		[ARCANE] = 5143, -- 5343 Arcane Missiles 
		[FIRE]   = 133,  -- 133 Fireball
		[FROST]  = 116, -- 116 Frostbolt
	},
	["DRUID"] = {
		[NATURE] = 5185, -- 5185 Healing Touch
	},
	["SHAMAN"] = {
		[NATURE]   = 403, -- 403 Lightning Bolt
		[FIRE]     = 8050, -- 8050 Flame Shock
		[FROST]    = 5394, -- 5394 Healing Stream Totem
		[PHYSICAL] = 8071, -- 8227 Flametongue Totem
	},
	["PRIEST"] = {
		[HOLY] = 585, --585 Smite
		[SHADOW] = 589, -- 589 Shadow Word: Pain
	},
	["PALADIN"] = {
		[HOLY] = 635, -- 635 Holy Light
	},
}

local school = {
	["WARLOCK"] = {
		[SHADOW] = {
			(GetSpellInfo(603)), -- 603 Curse of Doom
			(GetSpellInfo(698)), -- 698 Ritual of Summoning
			(GetSpellInfo(1122)), -- 1122 Inferno
			(GetSpellInfo(5484)), -- 5484 Howl of Terror
			(GetSpellInfo(6229)), -- 6229 Shadow Ward
			(GetSpellInfo(6789)), -- 6789 Death Coil
			(GetSpellInfo(17877)), -- 17877 Shadowburn
			(GetSpellInfo(18708)), -- 18708 Fel Domination
			(GetSpellInfo(18540)), -- 18540 Ritual of Doom
			(GetSpellInfo(29858)), -- 29858 Soulshatter
			(GetSpellInfo(29893)), -- 29893 Ritual of Souls
			(GetSpellInfo(47897)), -- 47897 Shadowflame
			(GetSpellInfo(48020)), -- 48020 Demonic Circle: Teleport
			(GetSpellInfo(48181)), -- 48181 Haunt 
		},
		[FIRE] = {
			(GetSpellInfo(47897)), -- 47897 Shadowflame
			(GetSpellInfo(50796)), -- 50796 Chaos Bolt
			(GetSpellInfo(17962)), -- 17962 Conflagrate
		},
	},
	["MAGE"] = {
		[ARCANE] = {
			(GetSpellInfo(66)), -- 66 Invisibility
			(GetSpellInfo(1953)), -- 1953 Blink
			(GetSpellInfo(2139)), -- 2139 Counterspell
			(GetSpellInfo(10059)), -- 10059 Portal: Stormwind
			(GetSpellInfo(11416)), -- 11416 Portal: Ironforge
			(GetSpellInfo(11417)), -- 11417 Portal: Orgrimmar
			(GetSpellInfo(11418)), -- 11418 Portal: Undercity
			(GetSpellInfo(11419)), -- 11419 Portal: Darnassus
			(GetSpellInfo(11420)), -- 11420 Portal: Thunder Bluff
			(GetSpellInfo(12042)), -- 12042 Arcane Power
			(GetSpellInfo(12043)), -- 12043 Presence of Mind
			(GetSpellInfo(12051)), -- 12051 Evocation
			(GetSpellInfo(32266)), -- 32266 Portal: Exodar
			(GetSpellInfo(32267)), -- 32267 Portal: Silvermoon
			(GetSpellInfo(33691)), -- 33691 Portal: Shattrath
		},
		[FIRE] = {
			(GetSpellInfo(543)), -- 543 Fire Ward
			(GetSpellInfo(1831)), -- 1831 Blast Wave
			(GetSpellInfo(2136)), -- 2136 Fire Blast
			(GetSpellInfo(31661)), -- 31661 Dragon's Breath
		},
		[FROST] = {
			(GetSpellInfo(120)), -- 120 Cone of Cold
			(GetSpellInfo(122)), -- 122 Frost Nova
			(GetSpellInfo(6143)), -- 6143 Frost Ward
			(GetSpellInfo(11426)), -- 11426 Ice Barrier
			(GetSpellInfo(31687)), -- 31687 Summon Water Elemental
			(GetSpellInfo(45438)), -- 45438 Ice Block
		},

	},
	["DRUID"] = {
		[NATURE] = {
			(GetSpellInfo(740)), -- 740 Tranquility
			(GetSpellInfo(29166)), -- 29166 Innervate
			(GetSpellInfo(20484)), -- 20484 Rebirth
			(GetSpellInfo(16857)), -- 16857 Faerie Fire (Feral)
			(GetSpellInfo(22812)),  -- 22812 Barkskin
			(GetSpellInfo(16689)), -- 16689 Nature's Grasp
			(GetSpellInfo(16914)), -- 16914 Hurricane
		},
	},
	["SHAMAN"] = {
		[NATURE] = {
			(GetSpellInfo(421)), -- 421 Chain Lightning
			(GetSpellInfo(556)), -- 556 Astral Recall
			(GetSpellInfo(2062)), -- 2062 Earth Elemental Totem
			(GetSpellInfo(2484)), -- 2484 Earthbind Totem
			(GetSpellInfo(2825)), -- 2825 Bloodlust
			(GetSpellInfo(5730)), -- 5730 Stoneclaw Totem
			(GetSpellInfo(8042)), -- 8042 Earth Shock
			(GetSpellInfo(8177)), -- 8177 Grounding Totem
			(GetSpellInfo(16166)), -- 16166 Elemental Mastery
			(GetSpellInfo(20608)), -- 20608 Reincarnation
			(GetSpellInfo(32182)), -- 32182 Heroism
		},
		[FIRE] = {
			(GetSpellInfo(2894)), -- 2894 Fire Elemental Totem
			(GetSpellInfo(1535)), -- 1535 Fire Nova Totem
			(GetSpellInfo(8050)), -- 8050 Flame Shock
		},
		[FIRE] = {
			(GetSpellInfo(8056)), -- 8056 Frost Shock
			(GetSpellInfo(16190)), -- 16190 Mana Tide Totem
		},
		[PHYSICAL] = {
			(GetSpellInfo(16188)), -- 16188 Nature's Swiftness
			(GetSpellInfo(17364)), -- 17364 Stormstrike
			(GetSpellInfo(30823)), -- 30823 Shamanistic Rage
		},
	},
	["PRIEST"] = {
		[SHADOW] = {
			(GetSpellInfo(586)), -- 586 Fade
			(GetSpellInfo(8092)), -- 8092 Mind Blast
			(GetSpellInfo(32379)), -- 32379 Shadow Word: Death
			(GetSpellInfo(15407)), -- 15407 Mind Flay
			(GetSpellInfo(34433)), -- 34433 Shadowfiend
		},
		[HOLY] = {
			(GetSpellInfo(19238)), -- 19238 Desperate Prayer
			(GetSpellInfo(15263)), -- 15263 Holy Fire
			(GetSpellInfo(27870)), -- 27870 Lightwell
			(GetSpellInfo(33076)), -- 33076 Prayer of Mending
			(GetSpellInfo(34863)), -- 34863 Circle of Healing
			(GetSpellInfo(47540)), -- 47540 Penance
			(GetSpellInfo(64843)), -- 64843 Divine Hymn
			(GetSpellInfo(64901)), -- 64901 Hymn of Hope
		},
	},
	["PALADIN"] = {
		[HOLY] = {
			(GetSpellInfo(498)), -- 498 Divine Protection
			(GetSpellInfo(633)), -- 633 Lay on Hands
			(GetSpellInfo(642)), -- 642 Divine Shield
			(GetSpellInfo(853)), -- 853 Hammer of Justice
			(GetSpellInfo(879)), -- 879 Exorcism
			(GetSpellInfo(2812)), -- 2812 Holy Wrath
			(GetSpellInfo(10326)), -- 10326 Turn Evil
			(GetSpellInfo(19752)), -- 19752 Divine Intervention
			(GetSpellInfo(20216)), -- 20216 Divine Favor
			(GetSpellInfo(20473)), -- 20473 Holy Shock
			(GetSpellInfo(20271)), -- 20271 Judgement of Light
			(GetSpellInfo(24275)), -- 24275 Hammer of Wrath
			(GetSpellInfo(26573)), -- 26573 Consecration
			(GetSpellInfo(31789)), -- 31789 Righteous Defense
			(GetSpellInfo(31842)), -- 31842 Divine Illumination
			(GetSpellInfo(31884)), -- 31884 Avenging Wrath
		},
	},
}

local whitelist = { 
	[(GetSpellInfo(47528))] = true,
}

Heatsink.slots = Heatsink.slots or {}
for k,v in pairs(slots) do
	Heatsink.slots[k] = v
end

Heatsink.substitution = Heatsink.substitution or {}
for k,v in pairs(substitution) do
	Heatsink.substitution[k] = v
end

Heatsink.schoolcd = Heatsink.schoolcd or {}
for k,v in pairs(schoolcd) do
	Heatsink.schoolcd[k] = v
end
  
Heatsink.school = Heatsink.school or {}
for k,v in pairs(school) do
	Heatsink.school[k] = v
end

Heatsink.whitelist = Heatsink.whitelist or {}
for k,v in pairs(whitelist) do
	Heatsink.whitelist[k] = v
end
